;*******************************************************************
;				BraMo5.06.ASM
;  Jeden vstup a jeden vstup.
;  Pi alarmu zavol na prvn slo ze seznamu SIM.
;  Pi pchozm voln ov platnost sla (nkter ze ty sel na SIM kart) a na vteinu sepne rel.
;
;	tel.: Siemens C10 ..?
;	Xtal=3,579Hz
;	IC=1,116us
;
;*******************************************************************

		LIST P=16f84A, R=DEC


;registry mikroprocesoru

indf		equ	00
rtcc		equ	01	;reg. citace
pc		equ	02	;citac instrukci
status		equ	03	;reg.
fsr		equ	04	;reg. neprimeho adresovani
porta		equ	05	;reg. portu A
portb		equ	06	;reg. portu B
eedata		equ	08
eeadr		equ	09
pclath		equ	10
intcon		equ	11
optr		equ     h'0081'
trisa	equ     h'0085'
trisb          	equ     h'0086'
eecon1		equ	h'0088'
eecon2		equ	h'0089'


;registry uzivatele

rxdat		equ	12	;prac.registr pro ukldn pijmutch dat
citac		equ	13	;pomocn ta
txdat		equ	14	;prac.reg.pro vyslan data
pocbit		equ	15	;potadlo odvyslanch bit
prac1		equ	16	;pomocn registr 1
sreg2		equ	17	;stavov reg. pomocn 2 (b0-H=vst1 pidrovn, L=vst1 uvolnn)
;                                (b7-H=prozvo, L=neprozvnt)
sreg		equ	18	;stavov reg. pomocn 1 (b0-H=vyst1 do H, L=vyst1 do L)
ram1		equ	19	;
ram2		equ	20	;
ram3		equ	21	;
ram4		equ	22	;
ram5		equ	23	;
ram6		equ	24	;
ram7		equ	25	;
ram8		equ	26	;
ram9		equ	27	;
ram10		equ	28	;
ram11		equ	29	;
ram12		equ	30	;
prac2           equ     31      ;pomocn registr 2
ram1b		equ	32	;
ram2b		equ	33	;
ram3b		equ	34	;
ram4b		equ	35	;
ram5b		equ	36	;
ram6b		equ	37	;
ram7b		equ	38	;
ram8b		equ	39	;
ram9b		equ	40	;
ram10b		equ	41	;
ram11b		equ	42	;
ram12b		equ	43	;


;definice symbol

#define		c	3,0		;CARRY bit v SWR
#define		rp0	status,5
#define		rp1	status,6
#define		rx	porta,0		;vstup Rx
#define		tx	porta,1		;vstup Tx
#define		led	porta,3		;LED
#define		rel1	portb,4		;vstup na RELE 1
#define		rd	eecon1,0
#define		wren	eecon1,2
#define		wr	eecon1,1
#define		pss1	sreg2,0		;indikuje jestli byl pslun spna oeten
#define		pss2	sreg2,1		;indikuje jestli byl pslun spna oeten
#define		pss3	sreg2,2		;indikuje jestli byl pslun spna oeten
#define		pss4	sreg2,3		;indikuje jestli byl pslun spna oeten
#define         pss8    sreg2,7         ;pznak jestli m dojt k prozvonn z MT
#define		sp1	portb,0		;vstup spnae 1
#define		sp2	portb,1		;vstup spnae 2
#define		sp3	portb,2		;vstup spnae 3
#define		sp4	portb,3		;vstup spnae 4

#define		hplus	h'2b'	;hodnota ASCI "+" v HEXa
#define		ha	h'41'	;	      "A"
#define		hb	h'42'	;	      "B"
#define		hr	h'52'	;	      "R"
#define		ht	h'54'	;             "T"
#define		hp	h'50'	;             "P"
#define		hc	h'43'	;             "C"
#define		hm	h'4d'	;             "M"
#define		hs	h'53'	;             "S"
#define		hh	h'48'	;             "H"
#define		hrovno	h'3d'	;             "="
#define		huvoz	h'22'	;             """
#define		hcarka	h'2c'	;             ","
#define		hstr	h'3b'	;             ";"
#define		hg	h'47'	;             "G"
#define		hl	h'4c'	;             "L"
#define		he	h'45'	;             "E"
#define		h0	h'30'	;             "0"
#define		hd	h'44'	;             "D"
#define		h1	h'31'	;             "1"
#define		h2	h'32'	;             "2"
#define		h3	h'33'	;             "3"
#define		h4	h'34'	;             "4"
#define		h5	h'35'	;             "5"
#define		h6	h'36'	;             "6"
#define		h7	h'37'	;             "7"
#define		h8	h'38'	;             "8"
#define		h9	h'39'	;             "9"
#define		hcr	h'0d'	;             "CR"
#define		hdvojt	h'3a'	;             ":"
#define		ho	h'4f'	;             "O"
#define		hi	h'49'	;             "I"


;*********************************************************************************************
;				RESET
;*********************************************************************************************

                                                                                              
	org	0
	goto	start

	org	4
	goto	start


;*********************************************************************************************
;				PODPROGRAMY
;*********************************************************************************************


scirx		bsf	c
		clrf	rxdat
		rrf	rxdat,f
s1		btfsc	rx	;test na start bit
		goto	s1
 		movlw	6	;casovn 26us (Tbit/2)
		movwf	citac	;poad.as (us)-4IC/3IC
st05		decfsz	citac,f
		goto	st05
st1 		movlw	13	;casovn 52us (Tbit)
		movwf	citac	;poad.as (us)-12IC/3IC
st1a		decfsz	citac,f
		goto	st1a
		btfsc	rx	;vzorkovn RX
		goto	sch
		bcf	c
		goto	s2
sch		bsf	c
s2		rrf	rxdat,f
		btfss	c	;test na konec byte
		goto	st1
 		movlw	7	;casovn 52us (Tbit)-as pro dobhnut byte
		movwf	citac	;poad.as (us)-12IC/3IC
st1b		decfsz	citac,f
		goto	st1b
		return		;pijat data jsou uloena v RXDAT


scitx		bsf	tx	;v TXDAT mus bt data pro vysln
		movlw	9	;do POCBITu 9
		movwf	pocbit
		bcf	tx	;start bit
st31 		movlw	12	;casovn 52us (Tbit)
		movwf	citac	;poad.as (us)-12IC/3IC
st31a		decfsz	citac,f
		goto	st31a
		decfsz	pocbit,f;test na konec odvys. bytu
		goto	s51
		bsf	tx	;stop bit
 		movlw	12	;casovn 52us (Tbit)=dlka stop bitu
		movwf	citac	;poad.as (us)-2IC/3IC
st32		decfsz	citac,f
		goto	st32
		return
s51		rrf	txdat,f
		btfsc	c	;test na stav aktulnho bitu
		goto	s4h
		bcf	tx
		goto	s41
s4h		bsf	tx
s41		goto	st31


;podpr. pro odesln znaku na SCI

odesli		movwf	txdat
		call	scitx
		return


;podprogram pro asov interval 147ms.

t147		bsf	rp0		;nast. banky 1
		movlw	b'00000111'	;pd=256,rtcc=128,citac=4
		movwf	optr
		bcf	rp0		;nast. banky 0
		clrf	citac
b147		clrf	rtcc
a147		btfss	rtcc,7
		goto	a147
		incf	citac,1
		btfss	citac,2
		goto	b147
		return


;podprogram pro asov interval asi 1,2s.

t1s		bsf	rp0		;nast. banky 1
		movlw	b'00000111'	;pd=256,rtcc=128,citac=32
		movwf	optr
		bcf	rp0		;nast. banky 0
		clrf	citac
skokb		clrf	rtcc
skoka		btfss	rtcc,7
		goto	skoka
		incf	citac,1
		btfss	citac,5
		goto	skokb
		return


;pesko dan poet pichzejcch byte do vstupu Rx

preskoc		movwf	prac1
preskoc2	call	scirx
		decfsz	prac1,f
		goto	preskoc2
		return


;program, kter provede ten z intern EEPROM
;adresa tenho byte mus bt v EEADR

ctiee		bsf	rp0		;nastaven banky 1
		bsf	rd		;RD v EECON1 do "H"
		bcf	rp0		;nastaven banky 0
		movfw	eedata
		return			; data jsou v registru W !


;program provede zpis do intern EEPROM
;adresa zapisovanho byte mus bt v EEADR a data v EEDATA

zapisee		bsf	rp0		;nastaven banky 1
		bsf	wren		;bit WREN v EECON1 do "H" - povolit zpis

		movlw	h'55'		;povinn povolovac sekvence
		movwf	eecon2
		movlw	h'aa'
		movwf	eecon2
		bsf	wr		;spustit zpis

zapiseeb	btfsc	wr		;ek na konec zpisu
		goto	zapiseeb
		bcf	wren		;zakzat zpis
		bcf	rp0		;nastavit banku 0
		return


;podpr. pro odesln do MT pkaz: AT+

atplus		movlw	ha		;AT+
		call	odesli
		movlw	ht
		call	odesli
		movlw	hplus
		call	odesli
		return


;zaven hovoru

zaves           movlw	ha              ;ATH<CR>
		call	odesli
		movlw	ht
		call	odesli
		movlw	hh
		call	odesli
		movlw	hcr
		call	odesli
                return


;reset RAM1 a RAM12

resram         	movlw	h'ff'
		movwf	ram1
		movwf	ram2
		movwf	ram3
		movwf	ram4
		movwf	ram5
		movwf	ram6
		movwf	ram7
		movwf	ram8
		movwf	ram9
		movwf	ram10
		movwf	ram11
		movwf	ram12
		return


;reset RAM1b a RAM12b

resramb        	movlw	h'ff'
		movwf	ram1b
		movwf	ram2b
		movwf	ram3b
		movwf	ram4b
		movwf	ram5b
		movwf	ram6b
		movwf	ram7b
		movwf	ram8b
		movwf	ram9b
		movwf	ram10b
		movwf	ram11b
		movwf	ram12b
		return


;nate pichzejc data z Rx do RAM1 a RAM12

plnram		call	scirx
		movfw	rxdat
		movwf	ram1
		call	scirx
		movfw	rxdat
		movwf	ram2
		call	scirx
		movfw	rxdat
		movwf	ram3
		call	scirx
		movfw	rxdat
		movwf	ram4
		call	scirx
		movfw	rxdat
		movwf	ram5
		call	scirx
		movfw	rxdat
		movwf	ram6
		call	scirx
		movfw	rxdat
		movwf	ram7
		call	scirx
		movfw	rxdat
		movwf	ram8
		call	scirx
		movfw	rxdat
		movwf	ram9
		call	scirx
		movfw	rxdat
		movwf	ram10
		call	scirx
		movfw	rxdat
		movwf	ram11
		call	scirx
		movfw	rxdat
		movwf	ram12
		return


;nate pichzejc data z Rx do RAM1b a RAM12b

plnramb		call	scirx
		movfw	rxdat
		movwf	ram1b
		call	scirx
		movfw	rxdat
		movwf	ram2b
		call	scirx
		movfw	rxdat
		movwf	ram3b
		call	scirx
		movfw	rxdat
		movwf	ram4b
		call	scirx
		movfw	rxdat
		movwf	ram5b
		call	scirx
		movfw	rxdat
		movwf	ram6b
		call	scirx
		movfw	rxdat
		movwf	ram7b
		call	scirx
		movfw	rxdat
		movwf	ram8b
		call	scirx
		movfw	rxdat
		movwf	ram9b
		call	scirx
		movfw	rxdat
		movwf	ram10b
		call	scirx
		movfw	rxdat
		movwf	ram11b
		call	scirx
		movfw	rxdat
		movwf	ram12b
		return


;nate telefonn slo z pozice 1 na SIM do RAM1 a RAM12
;(vyto AT+CPBR=1<CR> -> detekuj horn vozovky -> vynechej znak plus -> nati do RAM
; nsledujcch 12 byt -> ekej 147 ms)

ctitlf1         call    atplus          ;vyto AT+CPBR=1<CR>
                movlw   hc
                call    odesli
                movlw   hp
                call    odesli
                movlw   hb
                call    odesli
                movlw   hr
                call    odesli
                movlw   hrovno
                call    odesli
                movlw   h1
                call    odesli
                movlw   hcr
                call    odesli
ctit1a          call	scirx		;test na pchod horn vozovky (h22)
		movlw	h'22'
		clrz
		subwf	rxdat,w
		skpz
		goto    ctit1a
		movlw   1               ;pesko jeden pchoz znak (+)
		call    preskoc
                call    plnram          ;nate pichzejcch 12 byte do RAM (tlf. .)
                call    t147
                return


;nate telefonn slo z pozice 2 na SIM do RAM1 a RAM12
;(vyto AT+CPBR=1<CR> -> detekuj horn vozovky -> vynechej znak plus -> nati do RAM
; nsledujcch 12 byt -> ekej 147 ms)

ctitlf2         call    atplus          ;vyto AT+CPBR=2<CR>
                movlw   hc
                call    odesli
                movlw   hp
                call    odesli
                movlw   hb
                call    odesli
                movlw   hr
                call    odesli
                movlw   hrovno
                call    odesli
                movlw   h2
                call    odesli
                movlw   hcr
                call    odesli
ctit2a          call	scirx		;test na pchod horn vozovky (h22)
		movlw	h'22'
		clrz
		subwf	rxdat,w
		skpz
		goto    ctit2a
		movlw   1               ;pesko jeden pchoz znak (+)
		call    preskoc
                call    plnram          ;nate pichzejcch 12 byte do RAM (tlf. .)
                call    t147
                return


;nate telefonn slo z pozice 3 na SIM do RAM1 a RAM12
;(vyto AT+CPBR=1<CR> -> detekuj horn vozovky -> vynechej znak plus -> nati do RAM
; nsledujcch 12 byt -> ekej 147 ms)

ctitlf3         call    atplus          ;vyto AT+CPBR=3<CR>
                movlw   hc
                call    odesli
                movlw   hp
                call    odesli
                movlw   hb
                call    odesli
                movlw   hr
                call    odesli
                movlw   hrovno
                call    odesli
                movlw   h3
                call    odesli
                movlw   hcr
                call    odesli
ctit3a          call	scirx		;test na pchod horn vozovky (h22)
		movlw	h'22'
		clrz
		subwf	rxdat,w
		skpz
		goto    ctit3a
		movlw   1               ;pesko jeden pchoz znak (+)
		call    preskoc
                call    plnram          ;nate pichzejcch 12 byte do RAM (tlf. .)
                call    t147
                return


;nate telefonn slo z pozice 4 na SIM do RAM1 a RAM12
;(vyto AT+CPBR=1<CR> -> detekuj horn vozovky -> vynechej znak plus -> nati do RAM
; nsledujcch 12 byt -> ekej 147 ms)

ctitlf4         call    atplus          ;vyto AT+CPBR=4<CR>
                movlw   hc
                call    odesli
                movlw   hp
                call    odesli
                movlw   hb
                call    odesli
                movlw   hr
                call    odesli
                movlw   hrovno
                call    odesli
                movlw   h4
                call    odesli
                movlw   hcr
                call    odesli
ctit4a          call	scirx		;test na pchod horn vozovky (h22)
		movlw	h'22'
		clrz
		subwf	rxdat,w
		skpz
		goto    ctit4a
		movlw   1               ;pesko jeden pchoz znak (+)
		call    preskoc
                call    plnram          ;nate pichzejcch 12 byte do RAM (tlf. .)
                call    t147
                return


;vyto na MT tel. . uloen v RAM1 a RAM12
; vyto ATD+<tlf v RAM>;<CR> -> ekej 10s -> zavs MT -> ekej 147 ms

vytoctlf        movlw   ha               ;odele ATD+<tlf v RAM>;<CR>
                call    odesli
                movlw   ht
                call    odesli
                movlw   hd
                call    odesli
                movlw   hplus
                call    odesli
                movfw   ram1
                call    odesli
                movfw   ram2
                call    odesli
                movfw   ram3
                call    odesli
                movfw   ram4
                call    odesli
                movfw   ram5
                call    odesli
                movfw   ram6
                call    odesli
                movfw   ram7
                call    odesli
                movfw   ram8
                call    odesli
                movfw   ram9
                call    odesli
                movfw   ram10
                call    odesli
                movfw   ram11
                call    odesli
                movfw   ram12
                call    odesli
                movlw   hstr
                call    odesli
                movlw   hcr
                call    odesli
                call    t1s              ;ekn 15s - doba na prozvonn
                call    t1s
                call    t1s
                call    t1s
                call    t1s
                call    t1s
                call    t1s
                call    t1s
                call    t1s
                call    t1s
                call    t1s
                call    t1s
                call    t1s
                call    t1s
                call    t1s
                call    zaves            ;zaven hovoru
                call    t147             ;ekn 147 ms
                return


;porovn opbsah RAMa a RAMb. Pokud bude obsah stejn tak vrt v W 01h jinak 00h.*************

kompram         movfw   ram1
                clrz
                subwf   ram1b,w
                skpz
                goto    ret0

                movfw   ram2
                clrz
                subwf   ram2b,w
                skpz
                goto    ret0

                movfw   ram3
                clrz
                subwf   ram3b,w
                skpz
                goto    ret0

                movfw   ram4
                clrz
                subwf   ram4b,w
                skpz
                goto    ret0

                movfw   ram5
                clrz
                subwf   ram5b,w
                skpz
                goto    ret0

                movfw   ram6
                clrz
                subwf   ram6b,w
                skpz
                goto    ret0

                movfw   ram7
                clrz
                subwf   ram7b,w
                skpz
                goto    ret0

                movfw   ram8
                clrz
                subwf   ram8b,w
                skpz
                goto    ret0

                movfw   ram9
                clrz
                subwf   ram9b,w
                skpz
                goto    ret0

                movfw   ram10
                clrz
                subwf   ram10b,w
                skpz
                goto    ret0

                movfw   ram11
                clrz
                subwf   ram11b,w
                skpz
                goto    ret0

                movfw   ram12
                clrz
                subwf   ram12b,w
                skpz
                goto    ret0

                retlw   1                ;obsah RAMa je stejn s RAMb
ret0            retlw   0                ;obsah RAMa nen stejn s RAMb


;*********************************************************************************************
;				INICIALIZACE
;*********************************************************************************************


start		bcf	rp0		;nastaven banky 0
		bcf	rp1		;nastaven banky 0
		movlw	b'00011110'
		movwf	porta		;stav PORT A
		movlw	b'11101111'
		movwf	portb		;stav PORT B

		bsf	rp0		;nastaven banky 1
		movlw	b'00000001'
		movwf	trisa		;ini PORT A
		movlw	b'11101111'
		movwf	trisb		;ini PORT B

		bsf	rp0		;nast. banky 1
		movlw	b'00000011'	;nastaven OPTION (pull-up=ON, RTCC=16)
		movwf	optr
		movlw	b'00000000'	;zkaz peruen
		movwf	intcon
		clrf    sreg2           ;nulovn registru aktulnho stavu vstup

start1		bcf	rp0		;nast. banky 0

                call    resram          ;nulovn RAM1 - 12
                call    resramb         ;nulovn RAM1b - 12b

		movlw	0		;aktualizace SREG z EEPROM
		movwf	eeadr
		call	ctiee
		movwf	sreg


;*********************************************************************************************
;				PROGRAM
;*********************************************************************************************


program		bsf	led		;zhasni LED
		btfss	rx		;test na pipojen MT
		goto	program
		call	t147
		bcf	led		;rozsvi LED

                call    atplus          ;odesln AT+CLIP=1<CR> do MT (zapne indikaci tel. . pchozch hovor)
                movlw   hc
                call    odesli
                movlw   hl
                call    odesli
                movlw   hi
                call    odesli
                movlw   hp
                call    odesli
                movlw   hrovno
                call    odesli
                movlw   h1
                call    odesli
                movlw   hcr
                call    odesli
                call    t1s             ;prodleva pro zamaskovn odpovedi "OK" po pedchozm pkazu


;**** testovn vstup spnae a pchozho voln *********

testvst1        btfss   sp1             ;test na sepnut spnae vstupu 1
                goto    nulpss1
                btfsc   pss1            ;test jestli je stle sepnut vst.1 (v H)
                goto    cekej_t2
                bsf     pss1            ;nastaven e vst.1 byl sepnut

                call    t1s             ;doba na zotaven MT
                call    t1s
                call    t1s
                call    ctitlf1         ;nacte tlf. . z 1. pozice SIM do RAM1 - 12
                call    vytoctlf        ;vyto tlf. . z RAM do MT
                call    resram          ;nulovn RAM1 - 12

                goto    cekej_t2

nulpss1         bcf     pss1            ;nastaven e byl vst.1 uvolnn
cekej_t2        btfsc   rx              ;test na pchoz voln
                goto	testvst1


;**** zpracovn pchozho voln *****************************************
;jestli nen tet znak "R" tak zavesit a skoit na start1
;peskoit N znak
;nast vech 12 nsledujc sel do RAMb
;odmtnout pchoz hovor
;nast prvn tel. . ze SIM
;porovnat RAMa s RAMb
;
;pokud souhlas:
;zmnit stav rel (MKO)
;goto start1
;
;pokud nesouhlas:
;nast druh tel. . ze SIM
;porovnat RAMa s RAMb
;atd... a pro tvrt tel. .
;goto start1
;***************************************************************************

                movlw   2               ;peso dva pichzejc znaky
                call    preskoc
                call	scirx
                movlw   hr              ;test na prvn psmeno "RING"
		clrz
		subwf	rxdat,w
		skpz
		goto    navrat          ;pchoz znak nen "R" -> nvrat na start1

                movlw   15              ;pesko 12 pchozch znak
                call    preskoc

                call    plnramb         ;nate pchoz tel. . do RAMb
                call    t147            ;zotavovac doba MT
                call    zaves           ;ATH
                call    t147            ;zotavovac doba MT

                call    ctitlf1         ;nate tlf. . z 1. pozice SIM karty do RAMa
                call    kompram         ;porovn obsahy RAMa a RAMb
                movwf   prac2
                movlw   1
                clrz
                subwf   prac2,w
                skpnz
                goto    preprel         ;slo souhlas -> peklopit rel

                call    ctitlf2         ;nate tlf. . z 2. pozice SIM karty do RAMa
                call    kompram         ;porovn obsahy RAMa a RAMb
                movwf   prac2
                movlw   1
                clrz
                subwf   prac2,w
                skpnz
                goto    preprel         ;slo souhlas -> peklopit rel

                call    ctitlf3         ;nate tlf. . z 3. pozice SIM karty do RAMa
                call    kompram         ;porovn obsahy RAMa a RAMb
                movwf   prac2
                movlw   1
                clrz
                subwf   prac2,w
                skpnz
                goto    preprel         ;slo souhlas -> peklopit rel

                call    ctitlf4         ;nate tlf. . z 4. pozice SIM karty do RAMa
                call    kompram         ;porovn obsahy RAMa a RAMb
                movwf   prac2
                movlw   1
                clrz
                subwf   prac2,w
                skpnz
                goto    preprel         ;slo souhlas -> peklopit rel
                goto    start1

preprel         bsf     rel1            ;sepne rel
                call    t1s             ;doba sepnut rel
                bcf     rel1            ;vypne rel
		
navrat          call    zaves
                goto    start1		


		end